#include <stdio.h>
#include <stdlib.h>

#include "polyt.h"

// Pensez  documenter les procdures et fonctions faon "javadoc"


void zero(Polynome *P) {
    int i;
    (*P).degre = 0;
    for(i=0; i<(*P).degre; i++){
        (*P).coeff[i]=0;
    }
}

void plus(Polynome *P, float coeff, int deg) {

    (*P).coeff[deg] = (*P).coeff[deg] + coeff;
    if((*P).degre < deg){
        (*P).degre = deg;
    }

}

void add(Polynome P1,Polynome P2, Polynome *P3) {
   int i;
       for(i=0; i<LMAX; i++){
            (*P3).coeff[i]=P1.coeff[i]+P2.coeff[i];
       }
       if(P1.degre>P2.degre){
        (*P3).degre = P1.degre;
       }else{
        (*P3).degre = P2.degre;
       }
}

void soust(Polynome P1,Polynome P2, Polynome *P3) {
    int i;
    int j;
    int k;
    if(P1.degre + P2.degre > LMAX ){
        printf("ERREUR TROP ELEMENT");
    }else{
        i=0;
        j=0;
        k=0;

        while(i<=P1.degre && j<P2.degre){
            (*P3).coeff[k] = P1.coeff[i] - P2.coeff[j];
            k=k+1;
            i=i+1;
            j=j+1;
        }
        if(i>P1.degre){
            for(j=j; j<P2.degre; j++){
                (*P3).coeff[k] = P2.coeff[j];
                k=k+1;
            }
        }else{
            for(i=i; i<P1.degre; i++){
                (*P3).coeff[k] = P1.coeff[i];
                k= k +1;
            }
        }
        if(P1.degre >= P2.degre){
            (*P3).degre = P1.degre;
            (*P3).degre = P2.degre;
        }
    }
}

void mult(Polynome P1, Polynome P2,Polynome *P3) {
     int i;
    int j;
    int k;

   if(nul(P1)){
    zero(P3);
   }else{
        if(nul(P2)){
            zero(P3);
        }else{
            (*P3).degre = P1.degre + P2.degre;
            for(k=0; k <(*P3).degre; k++){
                (*P3).coeff[k]=0;
            }
            i=0;
            j=0;
            k=0;
            do{
                while(i<P1.degre && j<P2.degre){
                    if(P1.coeff[i] != 0){
                        k = i + j;
                        (*P3).coeff[k] = (P1.coeff[i]*P2.coeff[j])+(*P3).coeff[k];
                        j=j+1;
                    }
                }
                i = i+1;
                j=0;
            }while(i == P1.degre);

        }
   }
}

void multr(Polynome *P, float r) {
    int i;

    if(r == 0){
        nul(*P);
    }else{
        for(i=0; i<(*P).degre; i++){
            (*P).coeff[i] = (*P).coeff[i] * r;
        }
    }

}

void multm(Polynome *P, float coeff, int deg) {
    int i;
   if(coeff == 0){
        for(i=0; i<(*P).degre; i++){
            (*P).coeff[i]=0;
        }
        (*P).degre = 0;
   }else{
        if(deg <= (*P).degre){
            (*P).degre = deg + (*P).degre;
            for(i=0; i<(*P).degre; i++){
                i= i + deg;
                (*P).coeff[i] = (*P).coeff[i] * coeff;
            }
        }else{
            (*P).degre = deg + (*P).degre;
            for(i=0; i<(*P).degre; i++){
                i = i + deg;
                (*P).coeff[i] = (*P).coeff[i] * coeff;
            }
        }
   }
}

void deriv(Polynome P1,Polynome *P2) {
      int i;
    int j;

    for(i=0; i<P1.degre ; i++){
       j=i-1;
       (*P2).coeff[j]=P1.coeff[i]*i;
    }
    (*P2).degre= P1.degre ;
}

void copie(Polynome P1, Polynome *P2) {
    int i;

    for(i=0; i<P1.degre; i++){
        (*P2).coeff[i]=P1.coeff[i];
    }
    (*P2).degre = P1.degre;
}

Bool nul(Polynome P) {
     Bool Trouve;

   if(P.degre == 0 && P.coeff[0] == 0){
    Trouve = True;
   }else{
    Trouve = False;
   }
   return (Trouve);

}

int degre(Polynome P) {
    return(P.degre );
    return -1;
}

float coef(Polynome P, int i) {
     if(i>P.degre){
    printf("erreur :\n");
   }else{
    return(P.coeff[i]);
   }
    return -1.0;
}

float poly(Polynome P, float x) {
     float px;
     int i;

    for(i=P.degre; i>=1; i--){
        px = (px + P.coeff[i])*x;
    }
    px = px + P.coeff[0];
    return -1.0;
}

void affpol(Polynome P) {
   int i;

  if( nul(P) == True ) {
        printf("Polynome NUL.");
    }else {

        for(i=0; i<P.degre; i++){
            if(P.coeff[i] != 0){
                printf("%6.0f*X^%d ",P.coeff[i],i);
            }
            if( i != P.degre -1 ){
                printf("+");
            }
        }
 }
}
